/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.0
* Date               : 2020/09/25
* Description 		 : IAP
*******************************************************************************/

#include "CH57x_common.h"
#include "iap_config.h"

__attribute__((at(FLAG_BASE_ADDR)))
CONST UINT32 app_flag = APP_FLAG_VALID;

typedef int( *pImageTaskFn)( void );

void SystemInit(void)
{
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;		
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
    R16_CLK_SYS_CFG = (2<<6)|0x08;			// 32M -> Fsys
    R8_SAFE_ACCESS_SIG = 0;
}

static UINT32 JumpNext(void)
{
	CONST UINT32 *addr = (UINT32 *)FLAG_BASE_ADDR;
	return *addr == APP_FLAG_VALID ? APP_BASE_ADDR : IAP_BASE_ADDR;
}

static void GotoVector(INT32 IRQn)
{
	((pImageTaskFn *)JumpNext())[IRQn + 16]();
}

void NMI_Handler(void)
{
	GotoVector(NonMaskableInt_IRQn);
}

void HardFault_Handler(void)
{
	GotoVector(HardFault_IRQn);
}

void SVC_Handler(void)
{
	GotoVector(SVCall_IRQn);
}

void PendSV_Handler(void)
{
	GotoVector(PendSV_IRQn);
}

void SysTick_Handler(void)
{
	GotoVector(SysTick_IRQn);
}

void TMR0_IRQHandler(void)
{
	GotoVector(TMR0_IRQn);
}

void GPIO_IRQHandler(void)
{
	GotoVector(GPIO_IRQn);
}

void SLAVE_IRQHandler(void)
{
	GotoVector(SLAVE_IRQn);
}

void SPI0_IRQHandler(void)
{
	GotoVector(SPI0_IRQn);
}

void BB_IRQHandler(void)
{
	GotoVector(BLEB_IRQn);
}

void LLE_IRQHandler(void)
{
	GotoVector(BLEL_IRQn);
}

void USB_IRQHandler(void)
{
	GotoVector(USB_IRQn);
}

void ETH_IRQHandler(void)
{
	GotoVector(ETH_IRQn);
}

void TMR1_IRQHandler(void)
{
	GotoVector(TMR1_IRQn);
}

void TMR2_IRQHandler(void)
{
	GotoVector(TMR2_IRQn);
}

void UART0_IRQHandler(void)
{
	GotoVector(UART0_IRQn);
}

void UART1_IRQHandler(void)
{
	GotoVector(UART1_IRQn);
}

void RTC_IRQHandler(void)
{
	GotoVector(RTC_IRQn);
}

void ADC_IRQHandler(void)
{
	GotoVector(ADC_IRQn);
}

void SPI1_IRQHandler(void)
{
	GotoVector(SPI1_IRQn);
}

void LED_IRQHandler(void)
{
	GotoVector(LED_IRQn);
}

void TMR3_IRQHandler(void)
{
	GotoVector(TMR3_IRQn);
}

void UART2_IRQHandler(void)
{
	GotoVector(UART2_IRQn);
}

void UART3_IRQHandler(void)
{
	GotoVector(UART3_IRQn);
}

void WDT_IRQHandler(void)
{
	GotoVector(WDOG_BAT_IRQn);
}

int main()
{
	__set_MSP(((UINT32 *)JumpNext())[0]);
	GotoVector(-15);
    while(1);    
}






